/******************************************************************************
*                                                                             *
*                                                    *
*                                                     *
*                                                                             *
*   15  2004 .                                                        *
*   (C)                                                         *
*   e-mail       pavelkok@mail.ru                                             *
*   home page    http://kps.nm.ru                                             *
*                                                                             *
*                                                                             *
*   bitmap.h                                                                  *
*    GDI,    BMP, JPEG, PNG                          *
*                                                                             *
*******************************************************************************/


#ifndef BITMAP_H
#define BITMAP_H

#include "types.h"


const int iDefJpegQuality = 100;		// jpeg_set_quality(...)

class Bitmap
{
	friend Scene;
private:
	byte *pBitmap;
	int cx, cy;
	BITMAPINFOHEADER bmih;
	HBITMAP hbmBitmap;
	HDC hdcBitmap;
	void CreateBitmap(int cx, int cy);
	void DeleteBitmap();
public:
	Bitmap();
	Bitmap(int cx, int cy);
	Bitmap(wchar_t *fileName);
	~Bitmap();

	bool LoadFromFile(wchar *fileName);
	bool SaveToFile(wchar *fileName);

	bool LoadFromBmp(wchar *fileName);
	bool SaveToBmp(wchar *fileName);
	bool LoadFromJpeg(wchar *fileName);
	bool SaveToJpeg(wchar *fileName);
	bool LoadFromPng(wchar *fileName);
	bool SaveToPng(wchar *fileName);

	int GetWidth() { return cx; }
	int GetHeight() { return cy; }
	HBITMAP GetHandle() { return hbmBitmap; }
	HDC GetDC() { return hdcBitmap; }
	byte *GetData() { return pBitmap; }
	byte *GetScanLine(int y);
	COLORREF GetPixel(int x, int y);
	void SetPixel(int x, int y, COLORREF color);
	void GetColor(int x, int y, Color *color);
	void SetColor(int x, int y, const Color &color);
	void GetColorTile(int x, int y, Color *color);
	void SetColorTile(int x, int y, const Color &color);

	void DrawLine(int x1, int y1, int x2, int y2, COLORREF color);
	void DrawText(wchar *text, int i, int j, COLORREF color);
};

#endif
