#include "dialog.h"


void GetControlText(HWND hwnd, int id, wchar *str, int maxCount)
{
	HWND hwndCtrl = GetDlgItem(hwnd, id);
	GetWindowText(hwndCtrl, str, maxCount);
}

void SetControlText(HWND hwnd, int id, wchar *str)
{
	HWND hwndCtrl = GetDlgItem(hwnd, id);
	SetWindowText(hwndCtrl, str);
}


void SetEditValue(HWND hwnd, int id, REAL value)
{
	HWND hwndEdit = GetDlgItem(hwnd, id);
	wchar buf[256];
	swprintf(buf, stFloatEditFormat, value);
	SetWindowText(hwndEdit, buf);
}

void GetEditValue(HWND hwnd, int id, REAL *value, REAL min, REAL max, REAL def)
{
	HWND hwndEdit = GetDlgItem(hwnd, id);
	wchar buf[256];
	GetWindowText(hwndEdit, buf, 256);
	REAL x = def;
	swscanf(buf, L"%f", &x);
	if (x < min)
		x = min;
	else if (x > max)
		x = max;
	*value = x;
}


void SetCheckBoxState(HWND hwnd, int id, bool state)
{
	HWND hwndCtrl = GetDlgItem(hwnd, id);
	int istate = state? BST_CHECKED: BST_UNCHECKED;
	SendMessage(hwndCtrl, BM_SETCHECK, istate, 0);
}

void GetCheckBoxState(HWND hwnd, int id, bool *state)
{
	HWND hwndCtrl = GetDlgItem(hwnd, id);
	int istate = (int)SendMessage(hwndCtrl, BM_GETCHECK, 0, 0);
	*state = istate == BST_CHECKED;
}


void ComboBoxAdd(HWND hwnd, int id, int index, wchar *str)
{
	HWND hwndCtrl = GetDlgItem(hwnd, id);
	COMBOBOXEXITEM cbei;
	cbei.mask = CBEIF_TEXT;
	cbei.pszText = str;
	cbei.cchTextMax = (int)wcslen(str);
	cbei.iItem = index;
	SendMessage(hwndCtrl, CBEM_INSERTITEM, 0, (LPARAM)&cbei);
}

int GetComboBoxCurrSel(HWND hwnd, int id)
{
	HWND hwndCtrl = GetDlgItem(hwnd, id);
	return (int)SendMessage(hwndCtrl, CB_GETCURSEL, 0, 0);
}

void SetComboBoxCurrSel(HWND hwnd, int id, int index)
{
	HWND hwndCtrl = GetDlgItem(hwnd, id);
	SendMessage(hwndCtrl, CB_SETCURSEL, index, 0);
}
