/******************************************************************************
*                                                                             *
*                                                    *
*                                                     *
*                                                                             *
*   15  2004 .                                                        *
*   (C)                                                         *
*   e-mail       pavelkok@mail.ru                                             *
*   home page    http://kps.nm.ru                                             *
*                                                                             *
*                                                                             *
*   impt_ase.h                                                                *
*     3ds max ASE                                               *
*                                                                             *
*******************************************************************************/


#ifndef IMPT_ASE_H
#define IMPT_ASE_H

#include "impt_ase_ids.h"
#include "table.h"
#include "stream.h"
#include "scene.h"


class LoaderASE
{
private:
	PScene scene;
	FileStream stream;
	BinaryReader reader;
	char currChar;
	char strToken[256];
	int nLine;
	int lenToken;
	int idToken;
	REAL num;
	int inum;
	HashTable *hash;

	int firstFrame, lastFrame, ticksPerFrame;
	int TicksToSceneFrame(int ticks) { return ticks/ticksPerFrame - firstFrame; }

	void CreateTable();
	void NextChar() { if (!reader.ReadChar(&currChar)) currChar = '\0'; }
	void NextToken();

	void Check(int id);
	REAL GetNumber();
	int GetINumber();
	Vector GetVector();
	Quat GetQuat();
	Color GetColor();

	void SkipSpace();
	void SkipBlock();

	void Parse();
	void ParseScene();
	void ParseMaterialList();
	void ParseMaterial(int index);
	void ParseTexture(Texture **tex);

	void ParseGroup(Group *parent);
	void ParseGeometry(Group *parent);
	void ParseLight(Group *parent);
	void ParseCamera(Group *parent);

	void ParseNodeTM(Node *node);
	void ParseNodeTMAnimation(Node *node);

	void ParseMesh(Mesh *mesh);
	void ParseLightSettings(Light *light);

	void Warning(wchar *msg);
public:
	LoaderASE(wchar *fileName, PScene scene);
	~LoaderASE();
};


#endif 
