#include "stream.h"


Stream::~Stream()
{
}


FileStream::FileStream(wchar *fileName, FileStreamMode mode)
{
	switch (mode)
	{
	case fsmCreateNew:
		hfile = CreateFile(fileName, GENERIC_READ | GENERIC_WRITE, 0, NULL, CREATE_NEW, 0, NULL);
		break;
	case fsmCreateAlways:
		hfile = CreateFile(fileName, GENERIC_READ | GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL);
		break;
	case fsmTruncateExisting:
		hfile = CreateFile(fileName, GENERIC_READ | GENERIC_WRITE, 0, NULL, TRUNCATE_EXISTING, 0, NULL);
		break;
	case fsmOpenAlways:
		hfile = CreateFile(fileName, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, 0, NULL);
		break;
	case fsmOpenExisting:
		hfile = CreateFile(fileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		break;
	}
	if (hfile == INVALID_HANDLE_VALUE)
		throw L"Error create file handle";
}

FileStream::~FileStream()
{
	CloseHandle(hfile);
}

int FileStream::Read(void *buf, int len)
{
	ulong bytes;
	ReadFile(hfile, buf, len, &bytes, NULL);
	return (int)bytes;
}

int FileStream::Write(void *buf, int len)
{
	ulong bytes;
	WriteFile(hfile, buf, len, &bytes, NULL);
	return (int)bytes;
}


BinaryReader::BinaryReader(Stream *stream, int bufSize)
{
	this->stream = stream;
	this->bufSize = bufSize;
	this->bufLen = 0;
	this->bufPos = 0;

	buf = new byte[bufSize];
}

BinaryReader::~BinaryReader()
{
	delete buf;
}

bool BinaryReader::ReadChar(char *ch)
{
	if (bufPos < bufLen)
	{
		*ch = buf[bufPos++];
		return true;
	}
	else
	{
		bufLen = stream->Read(buf, bufSize);
		bufPos = 0;
		if (bufLen == 0)
			return false;
		return ReadChar(ch);
	}
}
