/******************************************************************************
*                                                                             *
*                                                    *
*                                                     *
*                                                                             *
*   15  2004 .                                                        *
*   (C)                                                         *
*   e-mail       pavelkok@mail.ru                                             *
*   home page    http://kps.nm.ru                                             *
*                                                                             *
*                                                                             *
*   stream.h                                                                  *
*                                                     *
*                                                                             *
*******************************************************************************/


#ifndef STREAM_H
#define STREAM_H

#include "types.h"


class Stream
{
private:
public:
	virtual ~Stream() = NULL;
	virtual int Read(void *buf, int len) = NULL;
	virtual int Write(void *buf, int len) = NULL;
};


enum FileStreamMode
{
	fsmCreateNew, fsmCreateAlways, fsmOpenExisting, fsmOpenAlways, fsmTruncateExisting
};


class FileStream: public Stream
{
private:
	HANDLE hfile;
	bool eof;
public:
	FileStream(wchar *fileName, FileStreamMode mode);
	~FileStream();
	int Read(void *buf, int len);
	int Write(void *buf, int len);
};


class BinaryReader
{
private:
	byte *buf;
	Stream *stream;
	int bufSize, bufLen, bufPos;
public:
	BinaryReader(Stream *stream, int bufSize);
	~BinaryReader();
	bool ReadChar(char *ch);
	bool ReadShort(short *x);
	bool ReadInt(int *x);
};


#endif
