/******************************************************************************
*                                                                             *
*                                                    *
*                                                     *
*                                                                             *
*   15  2004 .                                                        *
*   (C)                                                         *
*   e-mail       pavelkok@mail.ru                                             *
*   home page    http://kps.nm.ru                                             *
*                                                                             *
*                                                                             *
*   string.h                                                                  *
*     -                                      *
*                                                                             *
*******************************************************************************/


#ifndef STRING_H
#define STRING_H

#define UNICODE
#include <windows.h>
#include <wchar.h>


typedef wchar_t wchar;

class String
{
private:
	wchar *str;
public:
	String();
	String(char *str);
	String(wchar *str);
	~String();

	void SetString(wchar *str);
	void SetString(char *str);
	wchar *GetString() { return str; }
	int GetLength() { return str? (int)wcslen(str): 0; }

	void ToUpperCase() { wcsupr(str); }
	void ToLowerCase() { wcslwr(str); }
	wchar *SubString(wchar *subStr) { return wcsstr(str, subStr); }

	String &operator = (String &str);
	String &operator = (wchar *str);
	String &operator = (char *str);

	bool operator == (const String &s) { return wcscmp(this->str, s.str) == 0; }
	bool operator != (const String &s) { return wcscmp(this->str, s.str) != 0; }
};


#endif
