/******************************************************************************
*                                                                             *
*                                                    *
*                                                     *
*                                                                             *
*   15  2004 .                                                        *
*   (C)                                                         *
*   e-mail       pavelkok@mail.ru                                             *
*   home page    http://kps.nm.ru                                             *
*                                                                             *
*                                                                             *
*   triangle.h                                                                *
*     ,     ..                      *
*                                                                             *
*******************************************************************************/


#ifndef TRIANGLE_H
#define TRIANGLE_H

#include "types.h"


class Triangle
{
	friend Scene;
	friend Mesh;
private:
	Vector normalw;						//   
	Vector vw1, vw2;					//   (ptw1 - ptw0  ptw2 - ptw0)
	Vector ptw0, ptw1, ptw2;
	Vector normalw0, normalw1, normalw2;
	Vector bump_du, bump_dv;			//  ,   
	REAL ukx, uky, vkx, vky;
	int validPlane;
	REAL planeD;						// .  planeD = ax + by + cz
	REAL intersectU, intersectV;
	Vector intersectPt;
	Material *material;
	void Prepare();
	void PrepareWorldCoord(const Matrix &m);
	bool Intersect(const Vector &o, const Vector &dir, REAL *t);
	bool IsFrontPointw(const Vector &p) { return ScalarProduct(p, normalw) - planeD >= 0; }
	void GetIntersectNormalw(Vector *normal);
	void GetIntersectTexture(Vector *texture);
public:
	Vector pt0, pt1, pt2;
	Vector normal0, normal1, normal2;
	Vector texture0, texture1, texture2;
	Triangle();
	~Triangle();
};


#endif TRIANGLE_H
